package org.processmining.plugins.log.ui.logdialog;

import java.util.ArrayList;
import java.util.Collections;

import javax.swing.AbstractListModel;

import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XTrace;

public class AttributesListModel extends AbstractListModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = -719743180764113639L;
	protected XAttributeMap attributes;
	protected ArrayList<String> keys;

	protected AttributesListModel(XAttributeMap attributes) {
		if (attributes != null) {
			this.attributes = attributes;
			keys = new ArrayList<String>(attributes.keySet());
			Collections.sort(keys);
		} else {
			this.attributes = null;
			keys = null;
		}
	}

	public AttributesListModel(XEvent ate) {
		this(ate == null ? null : ate.getAttributes());
	}

	public AttributesListModel(XTrace instance) {
		this(instance == null ? null : instance.getAttributes());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.swing.ListModel#getElementAt(int)
	 */
	public Object getElementAt(int index) {
		return "<html><b>" + keys.get(index) + "</b>:  " + attributes.get(keys.get(index)) + "</html>";
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.swing.ListModel#getSize()
	 */
	public int getSize() {
		if (keys != null) {
			return keys.size();
		} else {
			return 0;
		}
	}

}